package com.jpsoft.campus.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

@Data
@ConfigurationProperties(prefix = "wechat")
@Component
public class WechatConfig {
    /**
     * 设置微信公众号或者小程序等的appid
     */
    private String appId;

    /**
     * 设置微信公众号或者小程序等的appSecret
     */
    private String appSecret;

    /**
     * 获取通用token地址
     */
    private String tokenUrl;

    /**
     * 退回通知模板编号
     */
    private String backNoticeTemplateId;
}
