package com.jpsoft.campus.modules.base.dao;

import java.util.List;

import com.jpsoft.campus.modules.base.dto.ApplicationPrimaryDTO;
import com.jpsoft.campus.modules.base.entity.ApplicationPrimary;
import com.jpsoft.campus.modules.base.entity.UserInformationCity;
import com.jpsoft.campus.modules.base.entity.UserInformationProvincial;
import org.springframework.stereotype.Repository;
import java.util.Map;
import com.jpsoft.campus.modules.common.dto.Sort;

@Repository
public interface ApplicationPrimaryDAO {
	int insert(ApplicationPrimary entity);
	int update(ApplicationPrimary entity);
	int exist(String id);
	ApplicationPrimary get(String id);
	int delete(String id);
	List<ApplicationPrimary> list();
	List<ApplicationPrimary> search(Map<String, Object> searchParams, List<Sort> sortList);
	List<ApplicationPrimaryDTO> searchDTO(Map<String, Object> searchParams, List<Sort> sortList);
    List<ApplicationPrimary> findByPersonId(String personId);
    long existByIdCard(String idCard, String applicationId);

	List<ApplicationPrimary> findByStudentId(String id);
	ApplicationPrimary findByStudentNameAndIdCard(String studentName, String idCard,String schoolId);
	List<ApplicationPrimary> findByIds(List<String> ids);
	List<UserInformationCity> findOffice();
	ApplicationPrimary findByOfficeCode(String officeCode);
	List<UserInformationProvincial> findOfficeByProvincial(Integer limit);
}