package com.jpsoft.campus.modules.base.dao;

import java.util.List;

import com.jpsoft.campus.modules.base.entity.SchoolInfo;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import java.util.Map;
import com.jpsoft.campus.modules.common.dto.Sort;

@Repository
public interface SchoolInfoDAO {
	int insert(SchoolInfo entity);
	int update(SchoolInfo entity);
	int exist(String id);
	SchoolInfo get(String id);
	int delete(String id);
	List<SchoolInfo> list();
	List<SchoolInfo> search(Map<String, Object> searchParams, List<Sort> sortList);
    List<SchoolInfo> findByEnrollmentType(String enrollmentType);
	long countByParentId(@Param("parentId") String parentId);
	List<SchoolInfo> findByParentId(@Param("parentId") String parentId);
	int updateParentIdNull(SchoolInfo model) ;

    List<SchoolInfo> findActiveSchoolByEnrollmentType(String type, String enrollmentType);
}