package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_application_middle的实体类
 */
@Data
@ApiModel(value = "base_application_middle的实体类")
public class ApplicationMiddle {


	/**
	 *
	 */
	@ApiModelProperty(value = "")
	private String id;
	/**
	 * 创建人
	 */
	@ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 * 创建时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 * 更新人
	 */
	@ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 * 更新时间
	 */
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 * 删除标示
	 */
	@ApiModelProperty(value = "删除标示")
	private Boolean delFlag = false;
	/**
	 * 报名类型(A,B,C)
	 */
	@ApiModelProperty(value = "报名类型(A,B,C)")
	private String type;
	/**
	 * 摇奖必中
	 */
	@ApiModelProperty(value = "摇奖必中")
	private String hit = "0";
	/**
	 * 审核状态
	 */
	@ApiModelProperty(value = "审核状态")
	private String status;
	/**
	 * 报名类型对应数据目录
	 */
	@ApiModelProperty(value = "报名类型对应数据目录")
	private String categoryId;
	/**
	 * 现居住地
	 */
	@ApiModelProperty(value = "现居住地")
	private String nowAddress;
	/**
	 * 申请用户ID
	 */
	@ApiModelProperty(value = "申请用户ID")
	private String personId;
	/**
	 * 申请学生ID
	 */
	@ApiModelProperty(value = "申请学生ID")
	private String studentId;
	/**
	 * 序号
	 */
	@ApiModelProperty(value = "序号")
	private Integer sortNo;

	@ApiModelProperty(value = "学校编号")
	private String schoolId;

	@ApiModelProperty(value = "所属街道")
	private String streetId;

	@ApiModelProperty(value = "所在社区")
	private String communityId;

	@ApiModelProperty(value = "择校原因")
	private String chooseReason;

	@ApiModelProperty(value = "录取编号")
	private String offerId;
	@ApiModelProperty(value = "录取学校名称")
	private String offerName;
	/**
	 *录取编号
	 */
	@ApiModelProperty(value = "录取编号")
	private String offerCode;

	@ApiModelProperty(value = "发送微信消息")
	private Boolean isSend;

	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
	@ApiModelProperty(value = "微信消息发送时间")
	private Date sendTime;

	@ApiModelProperty(value = "入学通知书")
	private String offerImg;

	@ApiModelProperty(value = "新类型")
	private String newType;


	@ApiModelProperty(value = "转校插班申报的年级ID")
	private String schoolNumberId;

	@ApiModelProperty(value = "转校插班申报的年级")
	private SchoolNumber schoolNumber;
}