package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_apportion_detail的实体类
 */
@Data
@ApiModel(value = "base_apportion_detail的实体类")
public class ApportionDetail {
	/**
	 *
	 */
        @ApiModelProperty(value = "")
	private String id;
	/**
	 *派位ID
	 */
        @ApiModelProperty(value = "派位ID")
	private String apportionId;
	/**
	 *申请ID
	 */
        @ApiModelProperty(value = "申请ID")
	private String applicationId;
	/**
	 *学生ID
	 */
        @ApiModelProperty(value = "学生ID")
	private String studentId;
	/**
	 *注册用户(家长)ID
	 */
        @ApiModelProperty(value = "注册用户(家长)ID")
	private String personId;
	/**
	 *录取学校ID
	 */
        @ApiModelProperty(value = "录取学校ID")
	private String schoolId;
	/**
	 *派位结果
	 */
	@ApiModelProperty(value = "派位结果")
    private Boolean winner;
	/**
	 *删除标示
	 */
        @ApiModelProperty(value = "删除标示")
	private Boolean delFlag = false;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;


	@ApiModelProperty(value = "录取学校名称")
	private String schoolName;
	@ApiModelProperty(value = "学生名称")
	private String studentName;
	@ApiModelProperty(value = "学生证件号")
	private String studentCard;
	@ApiModelProperty(value = "家长姓名")
	private String personName;
}