package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_approval_info的实体类
 */
@Data
@ApiModel(value = "base_approval_info的实体类")
public class ApprovalInfo {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 删除标示
     */
    @ApiModelProperty(value = "删除标示")
    private Boolean delFlag = false;
    /**
     * 申请ID
     */
    @ApiModelProperty(value = "申请ID")
    private String applicationId;
    /**
     * 执行操作
     */
    @ApiModelProperty(value = "执行操作")
    private String operation;
    /**
     * 备注信息
     */
    @ApiModelProperty(value = "备注信息")
    private String remark;
    /**
     * 审核文件
     */
    @ApiModelProperty(value = "审核文件")
    private String fileUrl;

    @ApiModelProperty(value = "审核文件列表")
    private List<String> fileUrlList;
}