package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_news_info的实体类
 */
@Data
@ApiModel(value = "base_news_info的实体类")
public class NewsInfo {
	/**
	 *
	 */
        @ApiModelProperty(value = "")
	private String id;
	/**
	 *类型:1轮播图新闻,2文字新闻
	 */
        @ApiModelProperty(value = "类型:1轮播图新闻,2文字新闻")
	private String type;
	/**
	 *标题
	 */
        @ApiModelProperty(value = "标题")
	private String title;
	/**
	 *副标题
	 */
	@ApiModelProperty(value = "副标题")
	private String subtitle;
	/**
	 *封面图
	 */
        @ApiModelProperty(value = "封面图")
	private String logo;
	/**
	 *备注
	 */
        @ApiModelProperty(value = "备注")
	private String remark;
	/**
	 *链接
	 */
        @ApiModelProperty(value = "链接")
	private String link;
	/**
	 *内容
	 */
        @ApiModelProperty(value = "内容")
	private String content;
	/**
	 *审核状态:0:未审核,1已审核,2关闭
	 */
        @ApiModelProperty(value = "审核状态:0:未审核,1已审核,2关闭")
	private String status;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *删除标示
	 */
        @ApiModelProperty(value = "删除标示")
	private Boolean delFlag = false;

	@ApiModelProperty(value = "排序号")
	private Integer sortNo;
}