package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_offer_info的实体类
 */
@Data
@ApiModel(value = "base_offer_info的实体类")
public class OfferInfo {
	/**
	 *
	 */
        @ApiModelProperty(value = "")
	private String id;
	/**
	 *学生ID
	 */
        @ApiModelProperty(value = "学生ID")
	private String studentId;
	/**
	 *申请单ID
	 */
        @ApiModelProperty(value = "申请单ID")
	private String applicationId;
	/**
	 *招生类型:(1小学一年级/2小升初
	 */
        @ApiModelProperty(value = "招生类型:(1小学一年级/2小升初")
	private String enrollmentType;
	/**
	 *录取学校ID
	 */
        @ApiModelProperty(value = "录取学校ID")
	private String schoolId;
	/**
	 *序号
	 */
        @ApiModelProperty(value = "序号")
	private Integer serialNum;
	/**
	 *录取编号
	 */
        @ApiModelProperty(value = "录取编号")
	private String code;
	/**
	 *报道时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "报道时间")
	private Date reportTime;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *删除标示
	 */
        @ApiModelProperty(value = "删除标示")
	private Boolean delFlag = false;
}