package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_person_info的实体类
 */
@Data
@ApiModel(value = "base_person_info的实体类")
public class PersonInfo {
	/**
	 *
	 */
	@ApiModelProperty(value = "主键")
	private String id;
	/**
	 *创建人
	 */
        @ApiModelProperty(value = "创建人")
	private String createBy;
	/**
	 *创建时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
	private Date createTime;
	/**
	 *更新人
	 */
        @ApiModelProperty(value = "更新人")
	private String updateBy;
	/**
	 *更新时间
	 */
    	@DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
	private Date updateTime;
	/**
	 *删除标示
	 */
        @ApiModelProperty(value = "删除标示")
	private Boolean delFlag = false;
	/**
	 *姓名
	 */
        @ApiModelProperty(value = "姓名")
	private String name;
	/**
	 *身份证
	 */
        @ApiModelProperty(value = "身份证")
	private String idCard;
	/**
	 *手机号
	 */
        @ApiModelProperty(value = "手机号")
	private String phone;
	/**
	 *微信openId
	 */
        @ApiModelProperty(value = "微信openId")
	private String openId;
	/**
	 *正式居住房类型
	 */
        @ApiModelProperty(value = "正式居住房类型")
	private String houseType;
	/**
	 *现居住地
	 */
        @ApiModelProperty(value = "现居住地")
	private String nowAddress;

	@ApiModelProperty(value = "一网通ID")
	private String uiasId;

	private String userId;

	private String userInfo;
	private String otherInfo;

}