package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_school_info的实体类
 */
@Data
@ApiModel(value = "base_school_info的实体类")
public class SchoolInfo {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 删除标示
     */
    @ApiModelProperty(value = "删除标示")
    private Boolean delFlag = false;
    /**
     * 学校名称
     */
    @ApiModelProperty(value = "学校名称")
    private String name;
    /**
     * 校园logo图片地址
     */
    @ApiModelProperty(value = "校园logo图片地址")
    private String logo;
    /**
     * 招生类型:(1小学一年级/2小升初
     */
    @ApiModelProperty(value = "招生类型:(1小学一年级/2小升初")
    private String enrollmentType;
    /**
     * 招生类型翻译
     */
    private String enrollmentTypeName;
    /**
     * 地址
     */
    @ApiModelProperty(value = "地址")
    private String address;
    /**
     * 招生电话
     */
    @ApiModelProperty(value = "招生电话")
    private String phone;
    /**
     * 讲师介绍
     */
    @ApiModelProperty(value = "讲师介绍")
    private String lectorIntroduction;
    /**
     * 经度
     */
    @ApiModelProperty(value = "经度")
    private String longitude;
    /**
     * 维度
     */
    @ApiModelProperty(value = "维度")
    private String latitude;

    /**
     *
     */
    @ApiModelProperty(value = "上级code")
    private String code;

    /**
     * 学校介绍
     */
    @ApiModelProperty(value = "学校介绍")
    private String introduction;

    /**
     * 学区
     */
    @ApiModelProperty(value = "学区")
    private String parentId;
    /**
     * 学区
     */
    @ApiModelProperty(value = "学区名称")
    private String parentName;

    @ApiModelProperty(value = "招生片区")
    private String district;

    @ApiModelProperty(value = "小升初招生片区")
    private String districtMiddle;

    /**
     * 学校编码"
     */
    @ApiModelProperty(value = "学校编码")
    private String schoolCode;

    @ApiModelProperty(value = "是否有子单位")
    private Boolean hasChildren;

    @ApiModelProperty(value = "类型/1学校/2校区")
    private String type;

    @ApiModelProperty(value = "是否开放报名")
    private Boolean isOpen;

    @ApiModelProperty(value = "排序号")
    private Integer sortNo;

    private List<SchoolNumber> schoolNumbers;
}