package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;
import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
  描述:base_school_number的实体类
 */
@Data
@ApiModel(value = "base_school_number的实体类")
public class SchoolNumber {
        @ApiModelProperty(value = "")
    private String id;
        @ApiModelProperty(value = "学校ID")
    private String schoolId;
        @ApiModelProperty(value = "招生类型:(1小学一年级/2小升初")
    private String enrollmentType;
        @ApiModelProperty(value = "年级")
    private String grade;
    @ApiModelProperty(value = "年级翻译")
    private String gradeStr;
        @ApiModelProperty(value = "人数")
    private Integer number;
        @ApiModelProperty(value = "创建人")
    private String createBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "创建时间")
    private Date createTime;
        @ApiModelProperty(value = "更新人")
    private String updateBy;
        @DateTimeFormat(pattern="yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm",timezone ="GMT+8")
	    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
        @ApiModelProperty(value = "删除标示")
    private Boolean delFlag;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone ="GMT+8")
    private Date startTime;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone ="GMT+8")
    private Date endTime;

}