package com.jpsoft.campus.modules.base.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @author 墨鱼_mo
 * @date 2020-7-2 14:27
 */
@Data
@ApiModel(value = "base_school_relation的实体类")
public class SchoolRelation {

    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 删除标示
     */
    @ApiModelProperty(value = "删除标示")
    private Boolean delFlag = false;


    /**
     * 小学id
     */
    @ApiModelProperty(value = "小学id")
    private String primaryId;

    /**
     * 中学id
     */
    @ApiModelProperty(value = "中学id")
    private String middleId;

    /**
     * 备注
     *
     */
    @ApiModelProperty(value = "备注")
    private String remark;

}
