package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_student_files的实体类
 */
@Data
@ApiModel(value = "base_student_files的实体类")
public class StudentFiles {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 删除标示
     */
    @ApiModelProperty(value = "删除标示")
    private Boolean delFlag = false;
    /**
     * 学生ID
     */
    @ApiModelProperty(value = "学生ID")
    private String studentId;
    /**
     * 附件类型
     */
    @ApiModelProperty(value = "附件类型")
    private String fileType;
    /**
     * 附件地址
     */
    @ApiModelProperty(value = "附件地址")
    private String fileUrl;
    /**
     * 申请表ID
     */
    @ApiModelProperty(value = "申请表ID")
    private String applicationId;

    @ApiModelProperty(value = "序号")
    private Integer sortNo;
}