package com.jpsoft.campus.modules.base.entity;

import java.io.Serializable;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.math.BigDecimal;

import org.springframework.format.annotation.DateTimeFormat;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 描述:base_student_info的实体类
 */
@Data
@ApiModel(value = "base_student_info的实体类")
public class StudentInfo {
    /**
     *
     */
    @ApiModelProperty(value = "")
    private String id;
    /**
     * 创建人
     */
    @ApiModelProperty(value = "创建人")
    private String createBy;
    /**
     * 创建时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 更新人
     */
    @ApiModelProperty(value = "更新人")
    private String updateBy;
    /**
     * 更新时间
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+8")
    @ApiModelProperty(value = "更新时间")
    private Date updateTime;
    /**
     * 删除标示
     */
    @ApiModelProperty(value = "删除标示")
    private Boolean delFlag = false;
    /**
     * 姓名
     */
    @ApiModelProperty(value = "姓名")
    private String name;
    /**
     * 曾用名
     */
    @ApiModelProperty(value = "曾用名")
    private String oldName;
    /**
     * 性别:1男2女
     */
    @ApiModelProperty(value = "性别:1男2女")
    private Integer sex;
    /**
     * 证件类型
     */
    @ApiModelProperty(value = "证件类型")
    private String cardType;
    /**
     * 身份证
     */
    @ApiModelProperty(value = "身份证")
    private String idCard;

    @ApiModelProperty(value = "证件上传地址")
    private String documentUrl;

    /**
     * 出生年月
     */
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @ApiModelProperty(value = "出生年月")
    private Date birthday;
    /**
     * 登记人姓名
     */
    @ApiModelProperty(value = "登记人姓名")
    private String registerName;
    /**
     * 登记人手机号
     */
    @ApiModelProperty(value = "登记人手机号")
    private String registerTel;
    /**
     * 审批状态
     */
    @ApiModelProperty(value = "审批状态")
    private String status;
    /**
     * 民族
     */
    @ApiModelProperty(value = "民族")
    private String nation;
    /**
     * 是否政策生
     */
    @ApiModelProperty(value = "是否政策生")
    private Boolean isPolicy;
    /**
     * 类型:小学,中学,大学等
     */
    @ApiModelProperty(value = "类型:小学,中学,大学等")
    private String type;

    @ApiModelProperty(value = "地址")
    private String address;

    @ApiModelProperty(value = "学籍号")
    private String studentNumber;

    @ApiModelProperty(value = "原学校")
    private String oldSchool;

    @ApiModelProperty(value = "原班级")
    private String oldClass;

    @ApiModelProperty(value = "户籍地址")
    private String residenceAddress;
}