package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.ApplicationMiddleDAO;
import com.jpsoft.campus.modules.base.dto.ApplicationMiddleDTO;
import com.jpsoft.campus.modules.base.entity.ApplicationMiddle;
import com.jpsoft.campus.modules.base.service.ApplicationMiddleService;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="applicationMiddleService")
public class ApplicationMiddleServiceImpl implements ApplicationMiddleService {
	@Resource(name="applicationMiddleDAO")
	private ApplicationMiddleDAO applicationMiddleDAO;

	@Override
	public ApplicationMiddle get(String id) {
		// TODO Auto-generated method stub
		return applicationMiddleDAO.get(id);
	}

	@Override
	public int insert(ApplicationMiddle model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());

		return applicationMiddleDAO.insert(model);
	}

	@Override
	public int update(ApplicationMiddle model) {
		// TODO Auto-generated method stub
		return applicationMiddleDAO.update(model);
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return applicationMiddleDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = applicationMiddleDAO.exist(id);

		return count > 0 ? true : false;
	}

	@Override
	public List<ApplicationMiddle> list() {
		// TODO Auto-generated method stub
		return applicationMiddleDAO.list();
	}

	@Override
	public Page<ApplicationMiddle> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<ApplicationMiddle> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            applicationMiddleDAO.search(searchParams,sortList);
        });

        return page;
	}

	@Override
	public Page<ApplicationMiddleDTO> pageSearchDTO(Map<String, Object> searchParams, int pageNumber, int pageSize, boolean count, List<Sort> sortList) {
		Page<ApplicationMiddleDTO> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
			applicationMiddleDAO.searchDTO(searchParams,sortList);
		});

		return page;
	}

	@Override
	public List<ApplicationMiddle> findByPersonId(String personId) {
		return applicationMiddleDAO.findByPersonId(personId);
	}

	@Override
	public boolean existByIdCard(String idCard, String applicationId) {
		long count = applicationMiddleDAO.existByIdCard(idCard, applicationId);

		return count>0;
	}

	@Override
	public List<ApplicationMiddle> findByStudentId(String id) {
		return applicationMiddleDAO.findByStudentId(id);
	}
}