package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.ApplicationPrimaryDAO;
import com.jpsoft.campus.modules.base.dto.ApplicationPrimaryDTO;
import com.jpsoft.campus.modules.base.entity.ApplicationPrimary;
import com.jpsoft.campus.modules.base.entity.UserInformationCity;
import com.jpsoft.campus.modules.base.entity.UserInformationProvincial;
import com.jpsoft.campus.modules.base.service.ApplicationPrimaryService;
import io.swagger.models.auth.In;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="applicationPrimaryService")
public class ApplicationPrimaryServiceImpl implements ApplicationPrimaryService {
	@Resource(name="applicationPrimaryDAO")
	private ApplicationPrimaryDAO applicationPrimaryDAO;

	@Override
	public ApplicationPrimary get(String id) {
		// TODO Auto-generated method stub
		return applicationPrimaryDAO.get(id);
	}

	@Override
	public int insert(ApplicationPrimary model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());

		return applicationPrimaryDAO.insert(model);
	}

	@Override
	public int update(ApplicationPrimary model) {
		// TODO Auto-generated method stub
		return applicationPrimaryDAO.update(model);
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return applicationPrimaryDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = applicationPrimaryDAO.exist(id);

		return count > 0 ? true : false;
	}

	@Override
	public List<ApplicationPrimary> list() {
		// TODO Auto-generated method stub
		return applicationPrimaryDAO.list();
	}

	@Override
	public Page<ApplicationPrimary> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<ApplicationPrimary> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            applicationPrimaryDAO.search(searchParams,sortList);
        });

        return page;
	}

	@Override
	public Page<ApplicationPrimaryDTO> pageSearchDTO(Map<String, Object> searchParams, int pageNumber, int pageSize, boolean count, List<Sort> sortList) {
		Page<ApplicationPrimaryDTO> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
			applicationPrimaryDAO.searchDTO(searchParams,sortList);
		});

		return page;
	}

	@Override
	public List<ApplicationPrimary> findByPersonId(String personId) {
		return applicationPrimaryDAO.findByPersonId(personId);
	}

	@Override
	public boolean existByIdCard(String idCard, String applicationId) {
		long count = applicationPrimaryDAO.existByIdCard(idCard, applicationId);

		return count>0;
	}

	@Override
	public List<ApplicationPrimary> findByStudentId(String id) {
		return applicationPrimaryDAO.findByStudentId(id);
	}

	@Override
	public ApplicationPrimary findByStudentNameAndIdCard(String studentName, String idCard,String schoolId){
		return applicationPrimaryDAO.findByStudentNameAndIdCard(studentName,idCard,schoolId);
	}

	@Override
	public List<ApplicationPrimary> findByIds(List<String> ids){
		return applicationPrimaryDAO.findByIds(ids);
	}

	@Override
	public List<UserInformationCity> findOffice(){
		return applicationPrimaryDAO.findOffice();
	}

	@Override
	public ApplicationPrimary findByOfficeCode(String officeCode){
		return applicationPrimaryDAO.findByOfficeCode(officeCode);
	}

	@Override
	public List<UserInformationProvincial> findOfficeByProvincial( Integer limit){
		return applicationPrimaryDAO.findOfficeByProvincial(limit);
	}
}