package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.ApportionDetailDAO;
import com.jpsoft.campus.modules.base.dto.ApportionDetailDTO;
import com.jpsoft.campus.modules.base.entity.ApportionDetail;
import com.jpsoft.campus.modules.base.service.ApportionDetailService;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="apportionDetailService")
public class ApportionDetailServiceImpl implements ApportionDetailService {
	@Resource(name="apportionDetailDAO")
	private ApportionDetailDAO apportionDetailDAO;

	@Override
	public ApportionDetail get(String id) {
		// TODO Auto-generated method stub
		return apportionDetailDAO.get(id);
	}

	@Override
	public int insert(ApportionDetail model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return apportionDetailDAO.insert(model);
	}

	@Override
	public int update(ApportionDetail model) {
		// TODO Auto-generated method stub
		return apportionDetailDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return apportionDetailDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = apportionDetailDAO.exist(id);
		
		return count > 0 ? true : false;
	}

	@Override
	public List<ApportionDetail> findByStudentId(String studentId){
		return apportionDetailDAO.findByStudentId(studentId);
	}
	
	@Override
	public List<ApportionDetail> list() {
		// TODO Auto-generated method stub
		return apportionDetailDAO.list();
	}
		
	@Override
	public Page<ApportionDetail> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<ApportionDetail> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            apportionDetailDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public Page<ApportionDetailDTO> pageSearchDTO(Map<String, Object> searchParams, int pageNumber, int pageSize, boolean count, List<Sort> sortList) {
		Page<ApportionDetailDTO> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
			apportionDetailDAO.pageSearchDTO(searchParams,sortList);
		});

		return page;
	}
}