package com.jpsoft.campus.modules.base.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.jpsoft.campus.modules.base.dao.EnrollControlDAO;
import com.jpsoft.campus.modules.base.entity.EnrollControl;
import com.jpsoft.campus.modules.base.service.EnrollControlService;
import com.jpsoft.campus.modules.common.dto.Sort;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @author 墨鱼_mo
 * @date 2020-7-17 13:15
 */
@Transactional
@Component(value="enrollControlService")
public class EnrollControlServiceImpl implements EnrollControlService {

    @Resource(name="enrollControlDAO")
    private EnrollControlDAO enrollControlDAO;

    @Override
    public EnrollControl get(String id) {
        // TODO Auto-generated method stub
        return enrollControlDAO.get(id);
    }

    @Override
    public int insert(EnrollControl model) {
        // TODO Auto-generated method stub
        //model.setId(UUID.randomUUID().toString());

        return enrollControlDAO.insert(model);
    }

    @Override
    public int update(EnrollControl model) {
        // TODO Auto-generated method stub
        return enrollControlDAO.update(model);
    }

    @Override
    public int delete(String id) {
        // TODO Auto-generated method stub
        return enrollControlDAO.delete(id);
    }

    @Override
    public boolean exist(String id) {
        // TODO Auto-generated method stub
        int count = enrollControlDAO.exist(id);

        return count > 0 ? true : false;
    }

    @Override
    public List<EnrollControl> list() {
        // TODO Auto-generated method stub
        return enrollControlDAO.list();
    }

    @Override
    public Page<EnrollControl> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize, boolean count, List<Sort> sortList) {
        Page<EnrollControl> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            enrollControlDAO.search(searchParams,sortList);
        });

        return page;
    }

    @Override
    public List<EnrollControl> findBySchoolTypeAndStudentType(String schoolType, String studentType) {
        return enrollControlDAO.findBySchoolTypeAndStudentType(schoolType,studentType);
    }

    @Override
    public List<EnrollControl> searchParam(Map<String, Object> searchParams,List<Sort> sortList) {
        return enrollControlDAO.search(searchParams,sortList);
    }
}
