package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.PersonInfoDAO;
import com.jpsoft.campus.modules.base.entity.PersonInfo;
import com.jpsoft.campus.modules.base.service.PersonInfoService;
import org.codehaus.jackson.map.ObjectMapper;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="personInfoService")
public class PersonInfoServiceImpl implements PersonInfoService {
	@Resource(name="personInfoDAO")
	private PersonInfoDAO personInfoDAO;

	@Override
	public PersonInfo get(String id) {
		// TODO Auto-generated method stub
		return personInfoDAO.get(id);
	}

	@Override
	public int insert(PersonInfo model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return personInfoDAO.insert(model);
	}

	@Override
	public int update(PersonInfo model) {
		// TODO Auto-generated method stub
		return personInfoDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return personInfoDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = personInfoDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<PersonInfo> list() {
		// TODO Auto-generated method stub
		return personInfoDAO.list();
	}
		
	@Override
	public Page<PersonInfo> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<PersonInfo> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            personInfoDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public PersonInfo findByPhone(String phone) {
		return personInfoDAO.findByPhone(phone);
	}

	@Override
	public PersonInfo findByOpenId(String openId) {
		return personInfoDAO.findByOpenId(openId);
	}

	@Override
	public PersonInfo findByIdCard(String idCard) {
		return personInfoDAO.findByIdCard(idCard);
	}

	@Override
	public PersonInfo findByUiasId(String uiasId){
		return personInfoDAO.findByUiasId(uiasId);
	}

	@Override
	public PersonInfo findByUserId(String userId){
		return personInfoDAO.findByUserId(userId);
	}

	@Override
	public Map findUiasUserByToken(String token){
		Map<String, Object> map = null;
//		try {
//			String path = Thread.currentThread().getContextClassLoader().getResource("").getPath();
//			String filePath = path;
//			//使用授权码换取token
//			final String fullUri = "https://oauth.hubei.gov.cn:8443/uias/unity/other_info";
//			HttpClientExecutor executor = new HttpClientExecutor(fullUri);
//			executor.addRequestParam("access_token", token);
//
//			String decrypto = "PKCS1";
//
//			JITResponseHandler responseHandler = new JITResponseHandler();
//			executor.execute(responseHandler, "get", filePath, decrypto);
//			JITObject jitObject = responseHandler.getObj();
//			String str = jitObject.getText();
//
//			ObjectMapper objectMapper = new ObjectMapper();
//			map = objectMapper.readValue(str, Map.class);
//			System.out.println("map：" + map);
//			System.out.println("用户详细信息json：" + str);
//
//		} catch (Exception e) {
//			e.printStackTrace();
//		}

		return map;
	}
}