package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.SchoolInfoDAO;
import com.jpsoft.campus.modules.base.entity.SchoolInfo;
import com.jpsoft.campus.modules.base.service.SchoolInfoService;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="schoolInfoService")
public class SchoolInfoServiceImpl implements SchoolInfoService {
	@Resource(name="schoolInfoDAO")
	private SchoolInfoDAO schoolInfoDAO;

	@Override
	public SchoolInfo get(String id) {
		// TODO Auto-generated method stub
		return schoolInfoDAO.get(id);
	}

	@Override
	public int insert(SchoolInfo model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return schoolInfoDAO.insert(model);
	}

	@Override
	public int update(SchoolInfo model) {
		// TODO Auto-generated method stub
		return schoolInfoDAO.update(model);
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return schoolInfoDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = schoolInfoDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<SchoolInfo> list() {
		// TODO Auto-generated method stub
		return schoolInfoDAO.list();
	}
		
	@Override
	public Page<SchoolInfo> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<SchoolInfo> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            schoolInfoDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public List<SchoolInfo> findByEnrollmentType(String enrollmentType) {
		return schoolInfoDAO.findByEnrollmentType(enrollmentType);
	}

	@Override
	public long countByParentId(String parentId) {
		return schoolInfoDAO.countByParentId(parentId);
	}

	@Override
	public Boolean hasChildren(String id) {
		return countByParentId(id)>0;
	}

	@Override
	public List<SchoolInfo> findByParentId(String parentId) {
		return schoolInfoDAO.findByParentId(parentId);
	}

	@Override
	public int updateParentIdNull(SchoolInfo model) {
		// TODO Auto-generated method stub
		return schoolInfoDAO.updateParentIdNull(model);
	}

	@Override
	public List<SchoolInfo> findActiveSchoolByEnrollmentType(String type, String enrollmentType) {
		return schoolInfoDAO.findActiveSchoolByEnrollmentType(type,enrollmentType);
	}
}