package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.campus.modules.base.dao.SchoolNumberDAO;
import com.jpsoft.campus.modules.base.entity.SchoolNumber;
import com.jpsoft.campus.modules.base.service.SchoolNumberService;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="schoolNumberService")
public class SchoolNumberServiceImpl implements SchoolNumberService {
	@Resource(name="schoolNumberDAO")
	private SchoolNumberDAO schoolNumberDAO;

	@Override
	public SchoolNumber get(String id) {
		// TODO Auto-generated method stub
		return schoolNumberDAO.get(id);
	}

	@Override
	public int insert(SchoolNumber model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return schoolNumberDAO.insert(model);
	}

	@Override
	public int update(SchoolNumber model) {
		// TODO Auto-generated method stub
		return schoolNumberDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return schoolNumberDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = schoolNumberDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<SchoolNumber> list() {
		// TODO Auto-generated method stub
		return schoolNumberDAO.list();
	}
		
	@Override
	public Page<SchoolNumber> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<SchoolNumber> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            schoolNumberDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public List<SchoolNumber> findByEnrollmentType(String enrollmentType){
		return schoolNumberDAO.findByEnrollmentType(enrollmentType);
	}

	@Override
	public List<SchoolNumber> findHaveNumberBySchoolId(String enrollmentType,String schoolId){
		return schoolNumberDAO.findHaveNumberBySchoolId(enrollmentType,schoolId);
	}

	@Override
	public List<SchoolNumber> findAllHaveNumber(){
		return schoolNumberDAO.findAllHaveNumber();
	}

	@Override
	public int findNumByHaveNumber(){
		return schoolNumberDAO.findNumByHaveNumber();
	}
}