package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.StudentFilesDAO;
import com.jpsoft.campus.modules.base.entity.StudentFiles;
import com.jpsoft.campus.modules.base.service.StudentFilesService;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="studentFilesService")
public class StudentFilesServiceImpl implements StudentFilesService {
	@Resource(name="studentFilesDAO")
	private StudentFilesDAO studentFilesDAO;

	@Override
	public StudentFiles get(String id) {
		// TODO Auto-generated method stub
		return studentFilesDAO.get(id);
	}

	@Override
	public int insert(StudentFiles model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return studentFilesDAO.insert(model);
	}

	@Override
	public int update(StudentFiles model) {
		// TODO Auto-generated method stub
		return studentFilesDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return studentFilesDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = studentFilesDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<StudentFiles> list() {
		// TODO Auto-generated method stub
		return studentFilesDAO.list();
	}
		
	@Override
	public Page<StudentFiles> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<StudentFiles> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            studentFilesDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public List<StudentFiles> findByApplicationIdAndFileType(String applicationId, String fileType) {
		return studentFilesDAO.findByApplicationIdAndFileType(applicationId,fileType);
	}

	@Override
	public int deleteByApplicationIdAndFileType(String applicationId, String fileType) {
		return studentFilesDAO.deleteByApplicationIdAndFileType(applicationId, fileType);
	}

	@Override
	public List<String> findUrlByApplicationIdAndFileType(String applicationId, String fileType) {
		return studentFilesDAO.findUrlByApplicationIdAndFileType(applicationId,fileType);
	}
}