package com.jpsoft.campus.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;

import com.jpsoft.campus.modules.base.dao.StudentInfoDAO;
import com.jpsoft.campus.modules.base.entity.StudentInfo;
import com.jpsoft.campus.modules.base.service.StudentInfoService;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.github.pagehelper.Page;
import com.jpsoft.campus.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="studentInfoService")
public class StudentInfoServiceImpl implements StudentInfoService {
	@Resource(name="studentInfoDAO")
	private StudentInfoDAO studentInfoDAO;

	@Override
	public StudentInfo get(String id) {
		// TODO Auto-generated method stub
		return studentInfoDAO.get(id);
	}

	@Override
	public int insert(StudentInfo model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return studentInfoDAO.insert(model);
	}

	@Override
	public int update(StudentInfo model) {
		// TODO Auto-generated method stub
		return studentInfoDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return studentInfoDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = studentInfoDAO.exist(id);
		
		return count > 0 ? true : false;
	}
	
	@Override
	public List<StudentInfo> list() {
		// TODO Auto-generated method stub
		return studentInfoDAO.list();
	}
		
	@Override
	public Page<StudentInfo> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,boolean count,List<Sort> sortList) {
        Page<StudentInfo> page = PageHelper.startPage(pageNumber,pageSize,count).doSelectPage(()->{
            studentInfoDAO.search(searchParams,sortList);
        });
        
        return page;
	}

	@Override
	public StudentInfo findByIdCard(String idCard) {
		return studentInfoDAO.findByIdCard(idCard);
	}
}