package com.jpsoft.campus.modules.base.service.impl;


import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.net.MediaType;
import com.google.gson.Gson;
import com.jpsoft.campus.modules.base.entity.ApplicationPrimary;
import com.jpsoft.campus.modules.base.entity.UserInformationProvincial;
import com.jpsoft.campus.modules.base.entity.UserInformationProvincialSubDeclares;
import com.jpsoft.campus.modules.base.service.ApplicationPrimaryService;
import com.jpsoft.campus.modules.base.service.UiasService;
import com.jpsoft.campus.modules.common.utils.FileUtil;
import com.jpsoft.campus.modules.common.utils.HttpConnectionUtil;
import com.jpsoft.campus.modules.common.utils.StringUtils;
import org.apache.http.client.methods.CloseableHttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.codehaus.jackson.map.ObjectMapper;
import org.omg.CORBA.Request;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.RequestBody;

import javax.crypto.Cipher;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.security.KeyFactory;
import java.security.PrivateKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.util.*;
import java.util.concurrent.TimeUnit;
import javax.net.ssl.*;
import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.security.cert.X509Certificate;
import java.util.Base64;

@Transactional
@Component(value="uiasServiceImpl")
public class UiasServiceImpl implements UiasService {
	@Override
	public String getToken(String code) {
		HashMap<String, Object> map = new HashMap<>();
		map.put("client_id","jzskfqwsruxgl");
		map.put("client_secret","jzskfqwsruxgl");
		map.put("grant_type","authorization_code");
		map.put("code",code);
		map.put("redirect_uri","http://wsbmapi.xiaoxinda.com/uias/externalRecback");

		String body = HttpRequest.post("https://oauth.hubei.gov.cn:8443/uias/oauth/token").form(map).execute().body();
		JSONObject jsonBody = JSONObject.parseObject(body);

		if (jsonBody!=null) {
			String accessToken = jsonBody.getString("access_token");
//			Integer expiresIn = jsonBody.getInteger("expires_in");

//			if (StringUtils.isNotBlank(accessToken) && expiresIn!=null) {
			if (StringUtils.isNotBlank(accessToken)) {
//				valueOperations.set("hikCloud_accessToken", accessToken, expiresIn, TimeUnit.SECONDS);
				return accessToken;
			} else {
				return "";
			}
		}
		else{
			return "";
		}
	}

	@Override
	public String logOut(String uiasId){
		HashMap<String, Object> map = new HashMap<>();
		map.put("sessionId","uiasId");
		map.put("goBack","");

		String body = HttpRequest.post("https://oauth.hubei.gov.cn:8443/uias/uias/LogOut").form(map).execute().body();
		JSONObject jsonBody = JSONObject.parseObject(body);

		if (jsonBody!=null) {
			String accessToken = jsonBody.getString("access_token");
//			Integer expiresIn = jsonBody.getInteger("expires_in");

//			if (StringUtils.isNotBlank(accessToken) && expiresIn!=null) {
			if (StringUtils.isNotBlank(accessToken)) {
//				valueOperations.set("hikCloud_accessToken", accessToken, expiresIn, TimeUnit.SECONDS);
				return accessToken;
			} else {
				return "";
			}
		}
		else{
			return "";
		}
	}

	@Override
	public String getProvincialToken(String path,String appId,String appSecret){
		HashMap<String, Object> map = new HashMap<>();
		map.put("key",appId);

		String body = HttpRequest.post(path + "/gateway/api/getToken").form(map).execute().body();
		JSONObject jsonBody = JSONObject.parseObject(body);

		if (jsonBody!=null) {
			String accessToken = jsonBody.toString();
			if (StringUtils.isNotBlank(accessToken)) {
				return accessToken;
			} else {
				return "";
			}
		}
		else{
			return "";
		}
	}

	@Override
	public String applyno(String path,String token) {
		try {
//			HashMap<String, Object> map = new HashMap<>();
//			map.put("sceneNo", "42PCN0010224J1003");
//			map.put("sceneBusiness", 4);

			HashMap<String, String> headersMap = new HashMap<>();
			headersMap.put("Authorization", token);

			JSONObject jsonObject = new JSONObject();
			jsonObject.put("sceneNo", "42PC00079A24");
			jsonObject.put("sceneBusiness", 4);

			String url = path + "/gateway/api/sbk/declare/ownerDeclare/applyno";

//			String jsonInputString = "{\"sceneNo\": \"42PC08017123\", \"sceneBusiness\": 4}";

			String jsonInputString = jsonObject.toString();
			try {
				// 信任所有证书
				TrustManager[] trustAllCerts = new TrustManager[]{
						new X509TrustManager() {
							public java.security.cert.X509Certificate[] getAcceptedIssuers() {
								return null;
							}

							public void checkClientTrusted(
									java.security.cert.X509Certificate[] certs, String authType) {
							}

							public void checkServerTrusted(
									java.security.cert.X509Certificate[] certs, String authType) {
							}
						}
				};

				SSLContext sslContext = SSLContext.getInstance("TLS");
				sslContext.init(null, trustAllCerts, new java.security.SecureRandom());

				HttpsURLConnection.setDefaultSSLSocketFactory(sslContext.getSocketFactory());

				// 忽略主机名验证
				HostnameVerifier allHostsValid = new HostnameVerifier() {
					public boolean verify(String hostname, SSLSession session) {
						return true;
					}
				};

				HttpsURLConnection.setDefaultHostnameVerifier(allHostsValid);

				// 创建连接
				URL obj = new URL(url);
				HttpURLConnection con = (HttpURLConnection) obj.openConnection();

				// 设置请求方法、输出、输入
				con.setRequestMethod("POST");
				con.setRequestProperty("Content-Type", "application/json; utf-8");
				con.setRequestProperty("Authorization", token);
				con.setDoOutput(true);

				// 发送POST输出
				try (OutputStream os = con.getOutputStream()) {
					byte[] input = jsonInputString.getBytes(StandardCharsets.UTF_8);
					os.write(input, 0, input.length);
				}

				int responseCode = con.getResponseCode();
				System.out.println("POST Response Code :: " + responseCode);

				BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
				String inputLine;
				StringBuilder response = new StringBuilder();

				while ((inputLine = in.readLine()) != null) {
					response.append(inputLine);
				}
				in.close();

				// 打印结果
				System.out.println(response.toString());

				String returnStr = response.toString();
				// 解析JSON字符串
				JSONObject returnJson = JSONObject.parseObject(returnStr);

				// 提取data字段的值
				String code = returnJson.getString("code");
				String data = returnJson.getString("data");

				return data;


			} catch (Exception e) {
				e.printStackTrace();
			}
		}catch (Exception e){
			e.printStackTrace();
		}

		return "";
	}

	@Override
	public String getUserInfo(String token) {
		HashMap<String, Object> map = new HashMap<>();
		map.put("access_token",token);

		String body = HttpRequest.post("https://oauth.hubei.gov.cn:8443/uias/unity/user_info").form(map).execute().body();
		JSONObject jsonBody = JSONObject.parseObject(body);

		if (jsonBody!=null) {
			String result = jsonBody.getString("result");

			if (StringUtils.isNotBlank(result)) {
				return result;
			} else {
				return "";
			}
		}
		else{
			return "";
		}
	}

	@Autowired
	private ApplicationPrimaryService applicationPrimaryService;
	@Override
	public Map submitAll(String path, String token, UserInformationProvincial provincial, UserInformationProvincialSubDeclares subDeclares){
		try {
//			HashMap<String, Object> map = new HashMap<>();
//			map.put("declare", provincial);
//
//			HashMap<String, String> headersMap = new HashMap<>();
//			headersMap.put("Authorization", token);
//
//			ObjectMapper objectMapper = new ObjectMapper();
//			String jsonString = objectMapper.writeValueAsString(map);
//			System.out.println(jsonString);

//			String body = HttpRequest.post(path + "/gateway/api/sbk/declare/subDeclare/submitAll").header("Authorization", token).form(jsonString).execute().body();
//			System.out.println(body);
//			JSONObject jsonBody = JSONObject.parseObject(body);

			JSONObject jsonObject = new JSONObject();
			jsonObject.put("declare",provincial);



			// 创建Gson对象
			Gson gson = new Gson();

			// 将实体类对象转换为JSON字符串
			String jsonString = gson.toJson(provincial);

			// 创建内部的JSONObject
			JSONObject declare = JSONObject.parseObject(jsonString);

			// 创建外部的JSONObject并添加内部对象和数组
			JSONObject root = new JSONObject();
			root.put("declare", declare);

			List<UserInformationProvincialSubDeclares> subDeclaressss = new ArrayList<>();
			subDeclaressss.add(subDeclares);
//			jsonObject.put("subDeclares",subDeclaressss);

			root.put("subDeclares", subDeclaressss);

			// 将JSONObject转换为字符串
			String jsonInputString = root.toString();
			System.out.println(jsonInputString);


			String url = path + "/gateway/api/sbk/declare/subDeclare/submitAll";
//			String jsonInputString = jsonObject.toString();
			try {
				// 信任所有证书
				TrustManager[] trustAllCerts = new TrustManager[]{
						new X509TrustManager() {
							public java.security.cert.X509Certificate[] getAcceptedIssuers() {
								return null;
							}

							public void checkClientTrusted(
									java.security.cert.X509Certificate[] certs, String authType) {
							}

							public void checkServerTrusted(
									java.security.cert.X509Certificate[] certs, String authType) {
							}
						}
				};

				SSLContext sslContext = SSLContext.getInstance("TLS");
				sslContext.init(null, trustAllCerts, new java.security.SecureRandom());

				HttpsURLConnection.setDefaultSSLSocketFactory(sslContext.getSocketFactory());

				// 忽略主机名验证
				HostnameVerifier allHostsValid = new HostnameVerifier() {
					public boolean verify(String hostname, SSLSession session) {
						return true;
					}
				};

				HttpsURLConnection.setDefaultHostnameVerifier(allHostsValid);

				// 创建连接
				URL obj = new URL(url);
				HttpURLConnection con = (HttpURLConnection) obj.openConnection();

				// 设置请求方法、输出、输入
				con.setRequestMethod("POST");
				con.setRequestProperty("Content-Type", "application/json; utf-8");
				con.setRequestProperty("Authorization", token);
				con.setDoOutput(true);

				// 发送POST输出
				try (OutputStream os = con.getOutputStream()) {
					byte[] input = jsonInputString.getBytes(StandardCharsets.UTF_8);
					os.write(input, 0, input.length);
				}

				int responseCode = con.getResponseCode();
				System.out.println("POST Response Code :: " + responseCode);

				BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
				String inputLine;
				StringBuilder response = new StringBuilder();

				while ((inputLine = in.readLine()) != null) {
					response.append(inputLine);
				}
				in.close();

				// 打印结果
				System.out.println(response.toString());

				String returnStr = response.toString();
				// 解析JSON字符串
				JSONObject returnJson = JSONObject.parseObject(returnStr);

				// 提取data字段的值
				String code = returnJson.getString("code");
				String data = returnJson.getString("data");

				Map returnMap = new HashMap();
				returnMap.put("code",code);
				returnMap.put("data",data);
				return returnMap;


			} catch (Exception e) {
				e.printStackTrace();
			}
		}catch (Exception e){
			e.printStackTrace();
		}
		return null;
	}
}