package com.jpsoft.campus.modules.mobile.controller;


import cn.hutool.json.JSONObject;
import com.jpsoft.campus.modules.base.entity.*;
import com.jpsoft.campus.modules.base.service.*;
import com.jpsoft.campus.modules.common.dto.MessageResult;
import com.jpsoft.campus.modules.common.utils.JwtUtil;
import com.jpsoft.campus.modules.sys.service.SysLogService;
import com.wfl.uias.dto.JITObject;
import com.wfl.uias.http.HttpClientExecutor;
import com.wfl.uias.servlet.JITResponseHandler;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;


import org.apache.commons.lang3.StringUtils;
import org.codehaus.jackson.map.ObjectMapper;
import org.joda.time.DateTime;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


import java.util.*;


/**
 * 问卷保存
 *
 */
@Slf4j
@Controller
@RequestMapping("/uias")
public class UiasApiController {
    @Value("${jwt.secret}")
    private String jwtSecret;
    @Autowired
    private SysLogService sysLogService;
    @Autowired
    private UiasService uiasService;
    @Autowired
    private PersonInfoService personInfoService;
    private final String decrypto = "PKCS1";


    @RequestMapping(value = "/externalRecback", method = {RequestMethod.POST, RequestMethod.GET})
    @ResponseBody
    public String externalRecback(HttpServletRequest request, HttpServletResponse response){

        MessageResult<Map> messageResult = new MessageResult<>();
        try {
            String code = (String)request.getParameter("code");
            String appCode = (String)request.getParameter("appCode");
            String state = (String)request.getParameter("state");
            String p03 = (String)request.getParameter("p03");
            String p04 = (String)request.getParameter("p04");
            String p05 = (String)request.getParameter("p05");
            String p06 = (String)request.getParameter("p06");
            String p07 = (String)request.getParameter("p07");
            String p08 = (String)request.getParameter("p08");
            String p09 = (String)request.getParameter("p09");
            String p10 = (String)request.getParameter("p10");


//            String url = "http://wsbm.xiaoxinda.com/#/external/index" + "?code=" + code + "&state=" + state;

            String html = "http://wsbm.xiaoxinda.com/#/external/index";
            String mobile = "http://wsbm.xiaoxinda.com/#/external/mobile";

            String token = uiasService.getToken(code);

            PersonInfo personInfo = personInfoService.findByUiasId(token);
            if(personInfo == null){
//                Map<String, Object> map = personInfoService.findUiasUserByToken(token);
                Map<String, Object> map = null;
                String path = Thread.currentThread().getContextClassLoader().getResource("").getPath();
                String filePath = path;
                //使用授权码换取token
                final String fullUri = "https://oauth.hubei.gov.cn:8443/uias/unity/other_info";
                HttpClientExecutor executor = new HttpClientExecutor(fullUri);
                executor.addRequestParam("access_token", token);

                String decrypto = "PKCS1";

                JITResponseHandler responseHandler = new JITResponseHandler();
                executor.execute(responseHandler, "get", filePath, decrypto);
                JITObject jitObject = responseHandler.getObj();
                String str = jitObject.getText();

                org.codehaus.jackson.map.ObjectMapper objectMapper = new ObjectMapper();
                map = objectMapper.readValue(str, Map.class);
                System.out.println("map：" + map);
                System.out.println("用户详细信息json：" + str);



                final String fullUri2 = "https://oauth.hubei.gov.cn:8443/uias/unity/user_info";
                HttpClientExecutor executor2 = new HttpClientExecutor(fullUri2);
                executor2.addRequestParam("access_token", token);

                JITResponseHandler responseHandler2 = new JITResponseHandler();
                executor2.execute(responseHandler2, "get", filePath, decrypto);
                JITObject jitObject2= responseHandler2.getObj();

                String str2 = jitObject2.getOriginalText();

                JSONObject jsonObject = new JSONObject(str2);

                String userId = jsonObject.get("userId").toString();

                System.out.println("用户详细信息json2：" + str2);

                if(map != null) {
                    String idCard = (String)map.get("id_card");

                    personInfo = personInfoService.findByUserId(userId);
                    if(personInfo == null) {
                        personInfo = personInfoService.findByIdCard(idCard);
                        if (personInfo == null) {
                            personInfo = new PersonInfo();
                            personInfo.setId(UUID.randomUUID().toString());
                            personInfo.setName((String) map.get("name"));
                            personInfo.setIdCard((String) map.get("id_card"));
                            personInfo.setPhone((String) map.get("mobile_phone"));
                            personInfo.setUiasId(token);
                            personInfo.setUserId(userId);
                            personInfo.setOtherInfo(str);
                            personInfo.setUserInfo(str2);

                            personInfo.setDelFlag(false);
                            personInfo.setCreateTime(new Date());

                            personInfoService.insert(personInfo);
                        } else {
                            personInfo.setUiasId(token);
                            personInfo.setUserId(userId);
                            personInfo.setOtherInfo(str);
                            personInfo.setUserInfo(str2);
                            personInfoService.update(personInfo);
                        }
                    }else{
                        personInfo.setUiasId(token);
                        personInfo.setUserId(userId);
                        personInfo.setOtherInfo(str);
                        personInfo.setUserInfo(str2);
                        personInfoService.update(personInfo);
                    }
                }else{
                    personInfo = new PersonInfo();
                    personInfo.setId(UUID.randomUUID().toString());
//                    personInfo.setName((String)map.get("name"));
//                    personInfo.setIdCard((String)map.get("id_card"));
//                    personInfo.setPhone((String)map.get("mobile_phone"));
                    personInfo.setUiasId(token);
                    personInfo.setUserId(userId);
                    personInfo.setOtherInfo(str);
                    personInfo.setUserInfo(str2);

                    personInfo.setDelFlag(false);
                    personInfo.setCreateTime(new Date());

                    personInfoService.insert(personInfo);
                }
            }

            String personToken = JwtUtil.createToken(jwtSecret, String.valueOf(personInfo.getId()), DateTime.now().plusHours(6).toDate());

            String url = html + "?token=" + personToken;

            if("02".equals(p10)){
                url = mobile + "?token=" + personToken;
            }

            response.setContentType("application/json;charset=utf-8");
            response.sendRedirect(url);
        } catch (Exception ex){
            log.error(ex.getMessage(),ex);

            messageResult.setCode(500);
            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }
        return null;
    }

    @PostMapping("getUserInfoByUiasId")
    @ApiOperation(value = "获取UIAS用户信息")
    @ResponseBody
    public MessageResult<Map> getUserInfoByUiasId(String uiasId) {
        MessageResult<Map> messageResult = new MessageResult<>();

        try {
//            Map<String, Object> map = personInfoService.findUiasUserByToken(uiasId);
            Map<String, Object> map = null;
            String path = Thread.currentThread().getContextClassLoader().getResource("").getPath();
            String filePath = path;
            //使用授权码换取token
            final String fullUri = "https://oauth.hubei.gov.cn:8443/uias/unity/other_info";

            HttpClientExecutor executor = new HttpClientExecutor(fullUri);
            executor.addRequestParam("access_token", uiasId);

            String decrypto = "PKCS1";

            JITResponseHandler responseHandler = new JITResponseHandler();
            executor.execute(responseHandler, "get", filePath, decrypto);
            JITObject jitObject = responseHandler.getObj();

            String str = jitObject.getText();


            org.codehaus.jackson.map.ObjectMapper objectMapper = new ObjectMapper();
            map = objectMapper.readValue(str, Map.class);
            System.out.println("map：" + map);
            System.out.println("用户详细信息json：" + str);


            final String fullUri2 = "https://oauth.hubei.gov.cn:8443/uias/unity/user_info";
            HttpClientExecutor executor2 = new HttpClientExecutor(fullUri2);
            executor2.addRequestParam("access_token", uiasId);

            JITResponseHandler responseHandler2 = new JITResponseHandler();
            executor2.execute(responseHandler2, "get", filePath, decrypto);
            JITObject jitObject2= responseHandler2.getObj();

            String str2 = jitObject2.getOriginalText();

            JSONObject jsonObject = new JSONObject(str2);
            String userId = jsonObject.get("userId").toString();

            map.put("userId",userId);

            System.out.println("用户详细信息json2：" + str2);
            System.out.println("用户详细信息json2：" + userId);

            messageResult.setData(map);
            messageResult.setResult(true);
        } catch (Exception ex) {
            log.error(ex.getMessage(), ex);

            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    @Autowired
    private ApplicationPrimaryService applicationPrimaryService;

    @PostMapping("uploadProvincialUser")
    @ApiOperation(value = "上传省级数据")
    @ResponseBody
    public MessageResult<Map> uploadProvincialUser(
            @RequestParam(value="schoolType",defaultValue="test") String status,
            @RequestParam(value="userId",defaultValue="") String userId,
            @RequestParam(value="limit",defaultValue="10") Integer limit,
            @RequestParam(value="token",defaultValue="") String token
            ) {
        MessageResult<Map> messageResult = new MessageResult<>();

        try {
            String path = "https://59.208.149.51:10087";
            String appId = "key_onethingApi_test_ztsbk_421000000000_jyzspt_13ee24a0c4244cdba2a10bdbf541516e";
            String appSecret = "secret_onethingApi_test_ztsbk_421000000000_jyzspt_b3670cf58542411c8605df86cee70a2e";
            if("real".equals(status)) {
                path = "https://59.208.149.51:10086/";//正式
                appId = "key_onethingApi_prod_ztsbk_421000000000_jyzspt_50a9bb4e0a80487c9f517672cb3ba36b";
                appSecret = "secret_onethingApi_prod_ztsbk_421000000000_jyzspt_764c9a3cf7f94633a0ebf1ff18f0057";
//                https://59.208.149.51:10086/gateway/api/getToken?key=key_onethingApi_prod_ztsbk_421000000000_jyzspt_50a9bb4e0a80487c9f517672cb3ba36b
//                token = uiasService.getProvincialToken(path,appId,appSecret);
            }


//            String token = "eyJhbGciOiJIUzUxMiIsInR5cCI6IkpXVCJ9.eyJrZXkiOiJrZXlfb25ldGhpbmdBcGlfdGVzdF96dHNia180MjEwMDAwMDAwMDBfanl6c3B0XzEzZWUyNGEwYzQyNDRjZGJhMmExMGJkYmY1NDE1MTZlIiwiZXhwIjoxNzI5MzAxNDczfQ._ZT6ceoP4CpWASjQhCC6NU2hO3BQLQPB9GTA90lS1Vx_vQSnpnETzHjIYqrS_6odhAXW2m-ToQ_usXy6qIV2Og";

//            String applyNo = "test";

            List<UserInformationProvincial> primaryList = applicationPrimaryService.findOfficeByProvincial(limit);
            List<Map> returnList = new ArrayList<>();
            for(UserInformationProvincial provincial : primaryList){
                String applyNo = uiasService.applyno(path,token);
                UserInformationProvincialSubDeclares subDeclares = new UserInformationProvincialSubDeclares();
                subDeclares.setApplicantName(provincial.getApplicantName());
                subDeclares.setApplicantPhone(provincial.getApplicantPhone());
                subDeclares.setApplyNo(applyNo);
                subDeclares.setSubApplyNo(applyNo);
                subDeclares.setLiceseNo(provincial.getLicenseNo());
                subDeclares.setTargetId(provincial.getTargetId());
                subDeclares.setTargetName(provincial.getTargetName());
                provincial.setApplyNo(applyNo);
                subDeclares.setSourceId(appId);

                UserInformationProvincialFileDeclares fileDeclares = new UserInformationProvincialFileDeclares();
                fileDeclares.setApplyNo(applyNo);
                fileDeclares.setSubApplyNo(applyNo);
                fileDeclares.setSourceId(appId);

                List<UserInformationProvincialFileDeclares> fileDeclaresList = new ArrayList<>();
                fileDeclaresList.add(fileDeclares);

//                subDeclares.setFileDeclares(fileDeclaresList);
                provincial.setSourceId(appId);

                if(StringUtils.isNotEmpty(userId)) {
                     provincial.setApplicantId(userId);
                }

                List<UserInformationProvincialSubDeclares> subDeclaresList = new ArrayList<>();
                subDeclaresList.add(subDeclares);
//                provincial.setSubDeclares(subDeclaresList);

                Map userMap = new HashMap();
                userMap.put("declare",provincial);
                returnList.add(userMap);

                Map returnMap = uiasService.submitAll(path,token,provincial,subDeclares);
                String code = (String)returnMap.get("code");
                String subNos = (String)returnMap.get("data");
                System.out.println(code);
                System.out.println(subNos);


                ApplicationPrimary primary = applicationPrimaryService.get(provincial.getAppId());
                primary.setCode(code);
                primary.setSubNos(subNos);
                primary.setUpdateTime(new Date());
                applicationPrimaryService.update(primary);
            }

            messageResult.setResult(true);
        } catch (Exception ex) {
            log.error(ex.getMessage(), ex);

            messageResult.setResult(false);
            messageResult.setMessage(ex.getMessage());
        }

        return messageResult;
    }

    public static void main(String[] args) {

            String url = "https://59.208.149.51:10086/gateway/api/getToken?key=key_onethingApi_prod_ztsbk_421000000000_jyzspt_50a9bb4e0a80487c9f517672cb3ba36";

    }
}
