package com.jpsoft.campus;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.json.JsonMapper;
import com.jpsoft.campus.config.WechatConfig;
import com.jpsoft.campus.modules.base.dto.ApplicationPrimaryDTO;
import com.jpsoft.campus.modules.base.dto.AttachmentDTO;
import org.joda.time.DateTime;
import org.joda.time.format.DateTimeFormat;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

@RunWith(SpringRunner.class)
@SpringBootTest
public class ApplicationPrimaryTest {
//    @Autowired
//    private PrimarySchoolApiController primarySchoolApi;

    @Autowired
    private WechatConfig wechatConfig;

    @Test
    public void testSubmit() throws JsonProcessingException {
        ApplicationPrimaryDTO dto = new ApplicationPrimaryDTO();

        String subject = "895390dd-7082-4de9-9f78-c553ff62d447";

        dto.setStreetId("49ef5c77-9f56-4942-9669-3766e58b237b"); //沙市农场
        dto.setCommunityId("6cd1bb84-b13a-11ea-a428-0250f2000002"); //玉桥
        dto.setSchoolId("2a161029-324a-4ef5-8062-4cf63339bcdc"); //荆州中学
        dto.setRelationship("1"); //父亲

        //单元测试无法测试@Validate
        dto.setName("");
        dto.setSex(2);

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        try {
            dto.setBirthday(sdf.parse("2013-09-01"));
        } catch (ParseException e) {
            e.printStackTrace();
        }

        dto.setAddress("荆州市沙市区玉桥公园");
        dto.setNation("汉");
        dto.setCardType("2");

        dto.setIdCard("421002201309011115");

        dto.setType(""); //A类辖区生

        //报名资料分类编号
        dto.setCategoryId("553669c4-2b68-4813-a39f-e7c05e58288b");

        List<AttachmentDTO> list1 = new ArrayList<>();
        AttachmentDTO dto1 = new AttachmentDTO();

        dto1.setId("86fce7b0-b17e-4773-8f37-d76120f8cbf8");
        dto1.setName("房屋所有权证或不动产权证书(已建有房屋)");
        dto1.setFiles(Arrays.asList("http://admission-46879.oss-cn-hangzhou.aliyuncs.com/person/1587825178894.jpg"));
        list1.add(dto1);

        dto.setRegistrationFileList(list1);

        List<AttachmentDTO> list2 = new ArrayList<>();
        AttachmentDTO dto2 = new AttachmentDTO();

        dto2.setId("4b9d043f-dd49-4919-9f15-4a436514b5aa");
        dto2.setName("适龄儿童出生证明");
        dto2.setFiles(Arrays.asList("http://admission-46879.oss-cn-hangzhou.aliyuncs.com/person/1587825178894.jpg"));

        list2.add(dto2);

        dto.setStudentCertificationFileList(list2);

        ObjectMapper mapper = new ObjectMapper();

        System.out.println("提交json");
        System.out.println(mapper.writeValueAsString(dto));

//        MessageResult<String> messageResult = primarySchoolApi.submit(dto, subject);
//
//        if (messageResult.isResult()){
//            MessageResult<Map> response = primarySchoolApi.detail(messageResult.getData(), subject);
//
//            System.out.println("返回json");
//            System.out.println(mapper.writeValueAsString(response.getData()));
//        }
    }

    @Test
    public void testDetail(){
        String applicationId = "93b6eb8d-5ac8-416b-b864-c37dc8660ab4";
        String subject = "895390dd-7082-4de9-9f78-c553ff62d447";

        //primarySchoolApi.detail(applicationId, subject);
    }

    @Test
    public void sendTemplate(){
//        WechatMessageUtil.sendBackTemplate("审批人",
//                "内容",
//                "备注",
//                "2020-07-12",
//                "ouJckwC1ysrEzgyF14X4pSJAPNFk",
//                wechatConfig.getBackNoticeTemplateId(),
//                wechatConfig.getTokenUrl(),
//                wechatConfig.getAppId(),
//                wechatConfig.getAppSecret());
    }
}
