package com.jpsoft.campus;

import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;

public class WatermarkTest {
    public static void main(String[] args) {
        try {
            String warkmark = "仅用于开发区网上入学报名使用";

            Image srcImage = ImageIO.read(new FileInputStream("E:\\杨雪婷正09112706388.jpg"));
            int imageWidth = srcImage.getWidth(null);
            int imageHeight = srcImage.getHeight(null);

            int fontHeight = imageHeight / 20;

            fontHeight = Math.min(30, fontHeight);

            Color color = new Color(128, 128, 128, 200);   // 水印颜色
            Font font = new Font("宋体", Font.ITALIC, fontHeight);  //水印字体

            BufferedImage bufferedImage = new BufferedImage(
                    srcImage.getWidth(null), srcImage.getHeight(null),
                    BufferedImage.TYPE_INT_RGB);

            Graphics2D g = bufferedImage.createGraphics();

            g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);
            g.drawImage(srcImage.getScaledInstance(imageWidth, imageHeight, Image.SCALE_SMOOTH), 0,
                    0, null);

            g.setColor(color); //水印颜色
            g.setFont(font); //水印字体

            int markWidth = g.getFontMetrics(g.getFont()).charsWidth(warkmark.toCharArray(), 0, warkmark.length());

            g.rotate(Math.toRadians(-45), imageWidth / 2, imageHeight / 2);

            for (int i=0;i<imageHeight/3;i++) {
                g.drawString(warkmark, (imageWidth - markWidth) / 2, imageHeight*i/3); //水印位置
            }

            g.dispose(); //释放资源

            FileOutputStream output = new FileOutputStream("E:\\身份证加水印.jpg");

            ImageIO.write(bufferedImage, "jpg", output);

            output.close();
        }
        catch (Exception ex){
            ex.printStackTrace();
        }
    }
}
